"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.RevertibleStatus = void 0;
/**
 * The status of a {@link Revertible}.
 *
 * @public
 */
var RevertibleStatus;
(function (RevertibleStatus) {
    /** The revertible can be reverted. */
    RevertibleStatus[RevertibleStatus["Valid"] = 0] = "Valid";
    /** The revertible has been disposed. Reverting it will have no effect. */
    RevertibleStatus[RevertibleStatus["Disposed"] = 1] = "Disposed";
})(RevertibleStatus || (exports.RevertibleStatus = RevertibleStatus = {}));
//# sourceMappingURL=revertible.js.map