"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DetachedFieldIndex = exports.tryGetChunk = exports.cursorChunk = exports.dummyRoot = exports.emptyDelta = exports.offsetDetachId = exports.makeDetachedNodeId = exports.isEmptyFieldChanges = exports.emptyFieldChanges = exports.deltaForRootInitialization = exports.getDescendant = exports.SparseNode = exports.makeDetachedFieldIndex = exports.combineVisitors = exports.createAnnouncedVisitor = exports.applyDelta = exports.announceDelta = exports.visitDelta = exports.aboveRootPlaceholder = exports.rootField = exports.rootFieldKey = exports.keyAsDetachedField = exports.detachedFieldAsKey = exports.EmptyKey = exports.EncodedJsonableTree = exports.setGenericTreeField = exports.getGenericTreeField = exports.genericTreeKeys = exports.genericTreeDeleteIfEmpty = exports.getDetachedFieldContainingPath = exports.compareFieldUpPaths = exports.compareUpPaths = exports.getDepth = exports.topDownPath = exports.clonePath = exports.deepCopyMapTree = exports.isCursor = exports.CursorMarker = exports.inCursorNode = exports.inCursorField = exports.iterateCursorField = exports.forEachField = exports.forEachNodeInSubtree = exports.forEachNode = exports.mapCursorFields = exports.mapCursorField = exports.castCursorToSynchronous = exports.CursorLocationType = exports.anchorSlot = exports.AnchorSet = void 0;
var anchorSet_js_1 = require("./anchorSet.js");
Object.defineProperty(exports, "AnchorSet", { enumerable: true, get: function () { return anchorSet_js_1.AnchorSet; } });
Object.defineProperty(exports, "anchorSlot", { enumerable: true, get: function () { return anchorSet_js_1.anchorSlot; } });
var cursor_js_1 = require("./cursor.js");
Object.defineProperty(exports, "CursorLocationType", { enumerable: true, get: function () { return cursor_js_1.CursorLocationType; } });
Object.defineProperty(exports, "castCursorToSynchronous", { enumerable: true, get: function () { return cursor_js_1.castCursorToSynchronous; } });
Object.defineProperty(exports, "mapCursorField", { enumerable: true, get: function () { return cursor_js_1.mapCursorField; } });
Object.defineProperty(exports, "mapCursorFields", { enumerable: true, get: function () { return cursor_js_1.mapCursorFields; } });
Object.defineProperty(exports, "forEachNode", { enumerable: true, get: function () { return cursor_js_1.forEachNode; } });
Object.defineProperty(exports, "forEachNodeInSubtree", { enumerable: true, get: function () { return cursor_js_1.forEachNodeInSubtree; } });
Object.defineProperty(exports, "forEachField", { enumerable: true, get: function () { return cursor_js_1.forEachField; } });
Object.defineProperty(exports, "iterateCursorField", { enumerable: true, get: function () { return cursor_js_1.iterateCursorField; } });
Object.defineProperty(exports, "inCursorField", { enumerable: true, get: function () { return cursor_js_1.inCursorField; } });
Object.defineProperty(exports, "inCursorNode", { enumerable: true, get: function () { return cursor_js_1.inCursorNode; } });
Object.defineProperty(exports, "CursorMarker", { enumerable: true, get: function () { return cursor_js_1.CursorMarker; } });
Object.defineProperty(exports, "isCursor", { enumerable: true, get: function () { return cursor_js_1.isCursor; } });
var mapTree_js_1 = require("./mapTree.js");
Object.defineProperty(exports, "deepCopyMapTree", { enumerable: true, get: function () { return mapTree_js_1.deepCopyMapTree; } });
var pathTree_js_1 = require("./pathTree.js");
Object.defineProperty(exports, "clonePath", { enumerable: true, get: function () { return pathTree_js_1.clonePath; } });
Object.defineProperty(exports, "topDownPath", { enumerable: true, get: function () { return pathTree_js_1.topDownPath; } });
Object.defineProperty(exports, "getDepth", { enumerable: true, get: function () { return pathTree_js_1.getDepth; } });
Object.defineProperty(exports, "compareUpPaths", { enumerable: true, get: function () { return pathTree_js_1.compareUpPaths; } });
Object.defineProperty(exports, "compareFieldUpPaths", { enumerable: true, get: function () { return pathTree_js_1.compareFieldUpPaths; } });
Object.defineProperty(exports, "getDetachedFieldContainingPath", { enumerable: true, get: function () { return pathTree_js_1.getDetachedFieldContainingPath; } });
var treeTextFormat_js_1 = require("./treeTextFormat.js");
Object.defineProperty(exports, "genericTreeDeleteIfEmpty", { enumerable: true, get: function () { return treeTextFormat_js_1.genericTreeDeleteIfEmpty; } });
Object.defineProperty(exports, "genericTreeKeys", { enumerable: true, get: function () { return treeTextFormat_js_1.genericTreeKeys; } });
Object.defineProperty(exports, "getGenericTreeField", { enumerable: true, get: function () { return treeTextFormat_js_1.getGenericTreeField; } });
Object.defineProperty(exports, "setGenericTreeField", { enumerable: true, get: function () { return treeTextFormat_js_1.setGenericTreeField; } });
var persistedTreeTextFormat_js_1 = require("./persistedTreeTextFormat.js");
Object.defineProperty(exports, "EncodedJsonableTree", { enumerable: true, get: function () { return persistedTreeTextFormat_js_1.EncodedJsonableTree; } });
var types_js_1 = require("./types.js");
Object.defineProperty(exports, "EmptyKey", { enumerable: true, get: function () { return types_js_1.EmptyKey; } });
Object.defineProperty(exports, "detachedFieldAsKey", { enumerable: true, get: function () { return types_js_1.detachedFieldAsKey; } });
Object.defineProperty(exports, "keyAsDetachedField", { enumerable: true, get: function () { return types_js_1.keyAsDetachedField; } });
Object.defineProperty(exports, "rootFieldKey", { enumerable: true, get: function () { return types_js_1.rootFieldKey; } });
Object.defineProperty(exports, "rootField", { enumerable: true, get: function () { return types_js_1.rootField; } });
Object.defineProperty(exports, "aboveRootPlaceholder", { enumerable: true, get: function () { return types_js_1.aboveRootPlaceholder; } });
var visitDelta_js_1 = require("./visitDelta.js");
Object.defineProperty(exports, "visitDelta", { enumerable: true, get: function () { return visitDelta_js_1.visitDelta; } });
var visitorUtils_js_1 = require("./visitorUtils.js");
Object.defineProperty(exports, "announceDelta", { enumerable: true, get: function () { return visitorUtils_js_1.announceDelta; } });
Object.defineProperty(exports, "applyDelta", { enumerable: true, get: function () { return visitorUtils_js_1.applyDelta; } });
Object.defineProperty(exports, "createAnnouncedVisitor", { enumerable: true, get: function () { return visitorUtils_js_1.createAnnouncedVisitor; } });
Object.defineProperty(exports, "combineVisitors", { enumerable: true, get: function () { return visitorUtils_js_1.combineVisitors; } });
Object.defineProperty(exports, "makeDetachedFieldIndex", { enumerable: true, get: function () { return visitorUtils_js_1.makeDetachedFieldIndex; } });
var sparseTree_js_1 = require("./sparseTree.js");
Object.defineProperty(exports, "SparseNode", { enumerable: true, get: function () { return sparseTree_js_1.SparseNode; } });
Object.defineProperty(exports, "getDescendant", { enumerable: true, get: function () { return sparseTree_js_1.getDescendant; } });
var deltaUtil_js_1 = require("./deltaUtil.js");
Object.defineProperty(exports, "deltaForRootInitialization", { enumerable: true, get: function () { return deltaUtil_js_1.deltaForRootInitialization; } });
Object.defineProperty(exports, "emptyFieldChanges", { enumerable: true, get: function () { return deltaUtil_js_1.emptyFieldChanges; } });
Object.defineProperty(exports, "isEmptyFieldChanges", { enumerable: true, get: function () { return deltaUtil_js_1.isEmptyFieldChanges; } });
Object.defineProperty(exports, "makeDetachedNodeId", { enumerable: true, get: function () { return deltaUtil_js_1.makeDetachedNodeId; } });
Object.defineProperty(exports, "offsetDetachId", { enumerable: true, get: function () { return deltaUtil_js_1.offsetDetachId; } });
Object.defineProperty(exports, "emptyDelta", { enumerable: true, get: function () { return deltaUtil_js_1.emptyDelta; } });
var chunk_js_1 = require("./chunk.js");
Object.defineProperty(exports, "dummyRoot", { enumerable: true, get: function () { return chunk_js_1.dummyRoot; } });
Object.defineProperty(exports, "cursorChunk", { enumerable: true, get: function () { return chunk_js_1.cursorChunk; } });
Object.defineProperty(exports, "tryGetChunk", { enumerable: true, get: function () { return chunk_js_1.tryGetChunk; } });
var detachedFieldIndex_js_1 = require("./detachedFieldIndex.js");
Object.defineProperty(exports, "DetachedFieldIndex", { enumerable: true, get: function () { return detachedFieldIndex_js_1.DetachedFieldIndex; } });
//# sourceMappingURL=index.js.map