/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import type { JsonValidator } from "../codec/index.js";
/**
 * A {@link JsonValidator} implementation which uses TypeBox's JSON schema validator.
 *
 * @privateRemarks Take care to not reference this validator directly in SharedTree code:
 * the intent of factoring JSON validation into an interface is to make validation more pay-to-play
 * (i.e. a JSON validator is only included in an application's bundle if that application references it).
 *
 * Defining this validator in its own file also helps to ensure it is tree-shakeable.
 *
 * @alpha
 */
export declare const typeboxValidator: JsonValidator;
//# sourceMappingURL=typeboxValidator.d.ts.map