"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createNodeKeyManager = exports.compareLocalNodeKeys = exports.makeFieldBatchCodec = exports.makeTreeChunker = exports.defaultChunkPolicy = exports.buildChunkedForest = exports.chunkFieldSingle = exports.chunkTree = exports.mapRootChanges = exports.posetLte = exports.comparePosetElements = exports.PosetComparisonResult = exports.fieldRealizer = exports.isNeverTree = exports.isRepoSuperset = exports.getAllowedContentDiscrepancies = exports.updateRefreshers = exports.EncodedModularChangeset = exports.ModularChangeFamily = exports.FieldKindWithEditor = exports.genericFieldKind = exports.allowsRepoSuperset = exports.FlexFieldKind = exports.CrossFieldTarget = exports.makeModularChangeCodecFamily = exports.ModularEditBuilder = exports.isNeverField = exports.SequenceField = exports.jsonableTreeFromForest = exports.jsonableTreeFromFieldCursor = exports.jsonableTreeFromCursor = exports.cursorForJsonableTreeField = exports.cursorForJsonableTreeNode = exports.stackTreeFieldCursor = exports.prefixFieldPath = exports.prefixPath = exports.stackTreeNodeCursor = exports.makeSchemaCodec = exports.encodeTreeSchema = exports.SchemaSummarizer = exports.buildForest = exports.mapTreeFieldFromCursor = exports.mapTreeFromCursor = exports.cursorForMapTreeNode = exports.cursorForMapTreeField = exports.ForestSummarizer = exports.isTreeValue = exports.assertAllowedValue = exports.allowsValue = exports.toDownPath = void 0;
exports.hasElement = exports.AnchorTreeIndex = exports.makeMitigatedChangeFamily = exports.EncodedSchemaChange = exports.makeSchemaChangeCodecs = exports.DetachedFieldIndexSummarizer = exports.valueSchemaAllows = exports.TreeCompressionStrategy = exports.FlexTreeEntityKind = exports.indexForAt = exports.treeStatusFromAnchorCache = exports.LazyEntity = exports.isFreedSymbol = exports.getSchemaAndPolicy = exports.flexTreeSlot = exports.assertFlexTreeEntityNotFreed = exports.flexTreeMarker = exports.ContextSlot = exports.isFlexTreeNode = exports.Context = exports.TreeStatus = exports.getTreeContext = exports.Skip = exports.isFieldInSchema = exports.isNodeInSchema = exports.SchemaValidationErrors = exports.relevantRemovedRoots = exports.intoDelta = exports.fieldKindConfigurations = exports.fieldKinds = exports.defaultSchemaPolicy = exports.DefaultEditBuilder = exports.DefaultChangeFamily = exports.FieldKinds = exports.nodeKeyTreeIdentifier = exports.MockNodeKeyManager = exports.isStableNodeKey = void 0;
var editableTreeBinder_js_1 = require("./editableTreeBinder.js");
Object.defineProperty(exports, "toDownPath", { enumerable: true, get: function () { return editableTreeBinder_js_1.toDownPath; } });
var valueUtilities_js_1 = require("./valueUtilities.js");
Object.defineProperty(exports, "allowsValue", { enumerable: true, get: function () { return valueUtilities_js_1.allowsValue; } });
Object.defineProperty(exports, "assertAllowedValue", { enumerable: true, get: function () { return valueUtilities_js_1.assertAllowedValue; } });
Object.defineProperty(exports, "isTreeValue", { enumerable: true, get: function () { return valueUtilities_js_1.isTreeValue; } });
var index_js_1 = require("./forest-summary/index.js");
Object.defineProperty(exports, "ForestSummarizer", { enumerable: true, get: function () { return index_js_1.ForestSummarizer; } });
var mapTreeCursor_js_1 = require("./mapTreeCursor.js");
Object.defineProperty(exports, "cursorForMapTreeField", { enumerable: true, get: function () { return mapTreeCursor_js_1.cursorForMapTreeField; } });
Object.defineProperty(exports, "cursorForMapTreeNode", { enumerable: true, get: function () { return mapTreeCursor_js_1.cursorForMapTreeNode; } });
Object.defineProperty(exports, "mapTreeFromCursor", { enumerable: true, get: function () { return mapTreeCursor_js_1.mapTreeFromCursor; } });
Object.defineProperty(exports, "mapTreeFieldFromCursor", { enumerable: true, get: function () { return mapTreeCursor_js_1.mapTreeFieldFromCursor; } });
var index_js_2 = require("./object-forest/index.js");
Object.defineProperty(exports, "buildForest", { enumerable: true, get: function () { return index_js_2.buildForest; } });
var index_js_3 = require("./schema-index/index.js");
Object.defineProperty(exports, "SchemaSummarizer", { enumerable: true, get: function () { return index_js_3.SchemaSummarizer; } });
Object.defineProperty(exports, "encodeTreeSchema", { enumerable: true, get: function () { return index_js_3.encodeTreeSchema; } });
Object.defineProperty(exports, "makeSchemaCodec", { enumerable: true, get: function () { return index_js_3.makeSchemaCodec; } });
var treeCursorUtils_js_1 = require("./treeCursorUtils.js");
Object.defineProperty(exports, "stackTreeNodeCursor", { enumerable: true, get: function () { return treeCursorUtils_js_1.stackTreeNodeCursor; } });
Object.defineProperty(exports, "prefixPath", { enumerable: true, get: function () { return treeCursorUtils_js_1.prefixPath; } });
Object.defineProperty(exports, "prefixFieldPath", { enumerable: true, get: function () { return treeCursorUtils_js_1.prefixFieldPath; } });
Object.defineProperty(exports, "stackTreeFieldCursor", { enumerable: true, get: function () { return treeCursorUtils_js_1.stackTreeFieldCursor; } });
var treeTextCursor_js_1 = require("./treeTextCursor.js");
Object.defineProperty(exports, "cursorForJsonableTreeNode", { enumerable: true, get: function () { return treeTextCursor_js_1.cursorForJsonableTreeNode; } });
Object.defineProperty(exports, "cursorForJsonableTreeField", { enumerable: true, get: function () { return treeTextCursor_js_1.cursorForJsonableTreeField; } });
Object.defineProperty(exports, "jsonableTreeFromCursor", { enumerable: true, get: function () { return treeTextCursor_js_1.jsonableTreeFromCursor; } });
Object.defineProperty(exports, "jsonableTreeFromFieldCursor", { enumerable: true, get: function () { return treeTextCursor_js_1.jsonableTreeFromFieldCursor; } });
Object.defineProperty(exports, "jsonableTreeFromForest", { enumerable: true, get: function () { return treeTextCursor_js_1.jsonableTreeFromForest; } });
// Split this up into separate import and export for compatibility with API-Extractor.
const SequenceField = __importStar(require("./sequence-field/index.js"));
exports.SequenceField = SequenceField;
var index_js_4 = require("./modular-schema/index.js");
Object.defineProperty(exports, "isNeverField", { enumerable: true, get: function () { return index_js_4.isNeverField; } });
Object.defineProperty(exports, "ModularEditBuilder", { enumerable: true, get: function () { return index_js_4.ModularEditBuilder; } });
Object.defineProperty(exports, "makeModularChangeCodecFamily", { enumerable: true, get: function () { return index_js_4.makeModularChangeCodecFamily; } });
Object.defineProperty(exports, "CrossFieldTarget", { enumerable: true, get: function () { return index_js_4.CrossFieldTarget; } });
Object.defineProperty(exports, "FlexFieldKind", { enumerable: true, get: function () { return index_js_4.FlexFieldKind; } });
Object.defineProperty(exports, "allowsRepoSuperset", { enumerable: true, get: function () { return index_js_4.allowsRepoSuperset; } });
Object.defineProperty(exports, "genericFieldKind", { enumerable: true, get: function () { return index_js_4.genericFieldKind; } });
Object.defineProperty(exports, "FieldKindWithEditor", { enumerable: true, get: function () { return index_js_4.FieldKindWithEditor; } });
Object.defineProperty(exports, "ModularChangeFamily", { enumerable: true, get: function () { return index_js_4.ModularChangeFamily; } });
Object.defineProperty(exports, "EncodedModularChangeset", { enumerable: true, get: function () { return index_js_4.EncodedModularChangeset; } });
Object.defineProperty(exports, "updateRefreshers", { enumerable: true, get: function () { return index_js_4.updateRefreshers; } });
Object.defineProperty(exports, "getAllowedContentDiscrepancies", { enumerable: true, get: function () { return index_js_4.getAllowedContentDiscrepancies; } });
Object.defineProperty(exports, "isRepoSuperset", { enumerable: true, get: function () { return index_js_4.isRepoSuperset; } });
Object.defineProperty(exports, "isNeverTree", { enumerable: true, get: function () { return index_js_4.isNeverTree; } });
Object.defineProperty(exports, "fieldRealizer", { enumerable: true, get: function () { return index_js_4.fieldRealizer; } });
Object.defineProperty(exports, "PosetComparisonResult", { enumerable: true, get: function () { return index_js_4.PosetComparisonResult; } });
Object.defineProperty(exports, "comparePosetElements", { enumerable: true, get: function () { return index_js_4.comparePosetElements; } });
Object.defineProperty(exports, "posetLte", { enumerable: true, get: function () { return index_js_4.posetLte; } });
var deltaUtils_js_1 = require("./deltaUtils.js");
Object.defineProperty(exports, "mapRootChanges", { enumerable: true, get: function () { return deltaUtils_js_1.mapRootChanges; } });
var index_js_5 = require("./chunked-forest/index.js");
Object.defineProperty(exports, "chunkTree", { enumerable: true, get: function () { return index_js_5.chunkTree; } });
Object.defineProperty(exports, "chunkFieldSingle", { enumerable: true, get: function () { return index_js_5.chunkFieldSingle; } });
Object.defineProperty(exports, "buildChunkedForest", { enumerable: true, get: function () { return index_js_5.buildChunkedForest; } });
Object.defineProperty(exports, "defaultChunkPolicy", { enumerable: true, get: function () { return index_js_5.defaultChunkPolicy; } });
Object.defineProperty(exports, "makeTreeChunker", { enumerable: true, get: function () { return index_js_5.makeTreeChunker; } });
Object.defineProperty(exports, "makeFieldBatchCodec", { enumerable: true, get: function () { return index_js_5.makeFieldBatchCodec; } });
var index_js_6 = require("./node-key/index.js");
Object.defineProperty(exports, "compareLocalNodeKeys", { enumerable: true, get: function () { return index_js_6.compareLocalNodeKeys; } });
Object.defineProperty(exports, "createNodeKeyManager", { enumerable: true, get: function () { return index_js_6.createNodeKeyManager; } });
Object.defineProperty(exports, "isStableNodeKey", { enumerable: true, get: function () { return index_js_6.isStableNodeKey; } });
Object.defineProperty(exports, "MockNodeKeyManager", { enumerable: true, get: function () { return index_js_6.MockNodeKeyManager; } });
Object.defineProperty(exports, "nodeKeyTreeIdentifier", { enumerable: true, get: function () { return index_js_6.nodeKeyTreeIdentifier; } });
var index_js_7 = require("./default-schema/index.js");
Object.defineProperty(exports, "FieldKinds", { enumerable: true, get: function () { return index_js_7.FieldKinds; } });
Object.defineProperty(exports, "DefaultChangeFamily", { enumerable: true, get: function () { return index_js_7.DefaultChangeFamily; } });
Object.defineProperty(exports, "DefaultEditBuilder", { enumerable: true, get: function () { return index_js_7.DefaultEditBuilder; } });
Object.defineProperty(exports, "defaultSchemaPolicy", { enumerable: true, get: function () { return index_js_7.defaultSchemaPolicy; } });
Object.defineProperty(exports, "fieldKinds", { enumerable: true, get: function () { return index_js_7.fieldKinds; } });
Object.defineProperty(exports, "fieldKindConfigurations", { enumerable: true, get: function () { return index_js_7.fieldKindConfigurations; } });
Object.defineProperty(exports, "intoDelta", { enumerable: true, get: function () { return index_js_7.intoDelta; } });
Object.defineProperty(exports, "relevantRemovedRoots", { enumerable: true, get: function () { return index_js_7.relevantRemovedRoots; } });
Object.defineProperty(exports, "SchemaValidationErrors", { enumerable: true, get: function () { return index_js_7.SchemaValidationErrors; } });
Object.defineProperty(exports, "isNodeInSchema", { enumerable: true, get: function () { return index_js_7.isNodeInSchema; } });
Object.defineProperty(exports, "isFieldInSchema", { enumerable: true, get: function () { return index_js_7.isFieldInSchema; } });
var index_js_8 = require("./flex-tree/index.js");
Object.defineProperty(exports, "Skip", { enumerable: true, get: function () { return index_js_8.Skip; } });
Object.defineProperty(exports, "getTreeContext", { enumerable: true, get: function () { return index_js_8.getTreeContext; } });
Object.defineProperty(exports, "TreeStatus", { enumerable: true, get: function () { return index_js_8.TreeStatus; } });
Object.defineProperty(exports, "Context", { enumerable: true, get: function () { return index_js_8.Context; } });
Object.defineProperty(exports, "isFlexTreeNode", { enumerable: true, get: function () { return index_js_8.isFlexTreeNode; } });
Object.defineProperty(exports, "ContextSlot", { enumerable: true, get: function () { return index_js_8.ContextSlot; } });
// Internal
Object.defineProperty(exports, "flexTreeMarker", { enumerable: true, get: function () { return index_js_8.flexTreeMarker; } });
Object.defineProperty(exports, "assertFlexTreeEntityNotFreed", { enumerable: true, get: function () { return index_js_8.assertFlexTreeEntityNotFreed; } });
Object.defineProperty(exports, "flexTreeSlot", { enumerable: true, get: function () { return index_js_8.flexTreeSlot; } });
Object.defineProperty(exports, "getSchemaAndPolicy", { enumerable: true, get: function () { return index_js_8.getSchemaAndPolicy; } });
Object.defineProperty(exports, "isFreedSymbol", { enumerable: true, get: function () { return index_js_8.isFreedSymbol; } });
Object.defineProperty(exports, "LazyEntity", { enumerable: true, get: function () { return index_js_8.LazyEntity; } });
Object.defineProperty(exports, "treeStatusFromAnchorCache", { enumerable: true, get: function () { return index_js_8.treeStatusFromAnchorCache; } });
Object.defineProperty(exports, "indexForAt", { enumerable: true, get: function () { return index_js_8.indexForAt; } });
Object.defineProperty(exports, "FlexTreeEntityKind", { enumerable: true, get: function () { return index_js_8.FlexTreeEntityKind; } });
var treeCompressionUtils_js_1 = require("./treeCompressionUtils.js");
Object.defineProperty(exports, "TreeCompressionStrategy", { enumerable: true, get: function () { return treeCompressionUtils_js_1.TreeCompressionStrategy; } });
var valueUtilities_js_2 = require("./valueUtilities.js");
Object.defineProperty(exports, "valueSchemaAllows", { enumerable: true, get: function () { return valueUtilities_js_2.valueSchemaAllows; } });
var detachedFieldIndexSummarizer_js_1 = require("./detachedFieldIndexSummarizer.js");
Object.defineProperty(exports, "DetachedFieldIndexSummarizer", { enumerable: true, get: function () { return detachedFieldIndexSummarizer_js_1.DetachedFieldIndexSummarizer; } });
var index_js_9 = require("./schema-edits/index.js");
Object.defineProperty(exports, "makeSchemaChangeCodecs", { enumerable: true, get: function () { return index_js_9.makeSchemaChangeCodecs; } });
Object.defineProperty(exports, "EncodedSchemaChange", { enumerable: true, get: function () { return index_js_9.EncodedSchemaChange; } });
var mitigatedChangeFamily_js_1 = require("./mitigatedChangeFamily.js");
Object.defineProperty(exports, "makeMitigatedChangeFamily", { enumerable: true, get: function () { return mitigatedChangeFamily_js_1.makeMitigatedChangeFamily; } });
var index_js_10 = require("./indexing/index.js");
Object.defineProperty(exports, "AnchorTreeIndex", { enumerable: true, get: function () { return index_js_10.AnchorTreeIndex; } });
Object.defineProperty(exports, "hasElement", { enumerable: true, get: function () { return index_js_10.hasElement; } });
//# sourceMappingURL=index.js.map