/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { type DetachedField, type ExclusiveMapTree, type ITreeCursor, type MapTree } from "../core/index.js";
import { type CursorWithNode } from "./treeCursorUtils.js";
/**
 * @returns An {@link ITreeCursorSynchronous} in nodes mode for a single {@link MapTree}.
 */
export declare function cursorForMapTreeNode(root: MapTree): CursorWithNode<MapTree>;
/**
 * @returns an {@link ITreeCursorSynchronous} in fields mode for a MapTree field.
 */
export declare function cursorForMapTreeField(root: MapTree[], detachedField?: DetachedField): CursorWithNode<MapTree>;
/**
 * Extract a MapTree from the contents of the given ITreeCursor's current node.
 */
export declare function mapTreeFromCursor(cursor: ITreeCursor): ExclusiveMapTree;
/**
 * Extract an array of MapTrees (a field) from the contents of the given ITreeCursor's current field.
 */
export declare function mapTreeFieldFromCursor(cursor: ITreeCursor): ExclusiveMapTree[];
//# sourceMappingURL=mapTreeCursor.d.ts.map