"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrossFieldTarget = exports.getFirstFromCrossFieldMap = exports.setInCrossFieldMap = exports.addCrossFieldQuery = void 0;
const index_js_1 = require("../../util/index.js");
function addCrossFieldQuery(set, revision, id, count) {
    setInCrossFieldMap(set, revision, id, count, true);
}
exports.addCrossFieldQuery = addCrossFieldQuery;
function setInCrossFieldMap(map, revision, id, count, value) {
    let rangeMap = map.get(revision);
    if (rangeMap === undefined) {
        rangeMap = new index_js_1.RangeMap();
        map.set(revision, rangeMap);
    }
    rangeMap.set(id, count, value);
}
exports.setInCrossFieldMap = setInCrossFieldMap;
function getFirstFromCrossFieldMap(map, revision, id, count) {
    const rangeMap = map.has(revision) ? map.get(revision) : new index_js_1.RangeMap();
    return rangeMap.get(id, count);
}
exports.getFirstFromCrossFieldMap = getFirstFromCrossFieldMap;
/**
 */
var CrossFieldTarget;
(function (CrossFieldTarget) {
    CrossFieldTarget[CrossFieldTarget["Source"] = 0] = "Source";
    CrossFieldTarget[CrossFieldTarget["Destination"] = 1] = "Destination";
})(CrossFieldTarget || (exports.CrossFieldTarget = CrossFieldTarget = {}));
//# sourceMappingURL=crossFieldQueries.js.map