"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.sequenceFieldChangeCodecFactory = void 0;
const index_js_1 = require("../../codec/index.js");
const sequenceFieldCodecV1_js_1 = require("./sequenceFieldCodecV1.js");
const sequenceFieldCodecV2_js_1 = require("./sequenceFieldCodecV2.js");
const sequenceFieldCodecV3_js_1 = require("./sequenceFieldCodecV3.js");
const sequenceFieldChangeCodecFactory = (revisionTagCodec) => (0, index_js_1.makeCodecFamily)([
    [1, (0, sequenceFieldCodecV1_js_1.makeV1Codec)(revisionTagCodec)],
    [2, (0, sequenceFieldCodecV2_js_1.makeV2Codec)(revisionTagCodec)],
    [3, (0, sequenceFieldCodecV3_js_1.makeV3Codec)(revisionTagCodec)],
]);
exports.sequenceFieldChangeCodecFactory = sequenceFieldChangeCodecFactory;
//# sourceMappingURL=sequenceFieldCodecs.js.map