"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeCompressionStrategy = void 0;
/**
 * Selects which heuristics to use when encoding tree content.
 * All encoding options here are compatible with the same decoder:
 * the selection here does not impact compatibility.
 * @alpha
 */
var TreeCompressionStrategy;
(function (TreeCompressionStrategy) {
    /**
     * Optimized for encoded size.
     * Use this in production to reduce bandwidth and storage use.
     */
    TreeCompressionStrategy[TreeCompressionStrategy["Compressed"] = 0] = "Compressed";
    /**
     * Optimized for human readability.
     * Use this when debugging or testing and needing to inspect encoded tree content.
     */
    TreeCompressionStrategy[TreeCompressionStrategy["Uncompressed"] = 1] = "Uncompressed";
})(TreeCompressionStrategy || (exports.TreeCompressionStrategy = TreeCompressionStrategy = {}));
//# sourceMappingURL=treeCompressionUtils.js.map