"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_RecursiveObjectPojoMode = exports.test_RecursiveObject_base = exports.test_RecursiveObject = exports.comparePersistedSchema = exports.comparePersistedSchemaInternal = exports.extractPersistedSchema = exports.createIdentifierIndex = exports.createSimpleTreeIndex = exports.TreeBeta = exports.conciseFromCursor = exports.tryStoredSchemaAsArray = exports.customFromCursorStored = exports.verboseFromCursor = exports.cursorFromVerbose = exports.applySchemaToParserOptions = exports.ViewSchema = exports.getSimpleSchema = exports.getJsonSchema = exports.createFromCursor = exports.cursorFromInsertable = exports.createFromInsertable = exports.tryGetSchema = exports.treeNodeApi = exports.singletonSchema = exports.enumFromStrings = exports.adaptEnum = exports.SchemaFactoryAlpha = exports.SchemaFactory = exports.asTreeViewAlpha = exports.TreeViewConfiguration = void 0;
var tree_js_1 = require("./tree.js");
Object.defineProperty(exports, "TreeViewConfiguration", { enumerable: true, get: function () { return tree_js_1.TreeViewConfiguration; } });
Object.defineProperty(exports, "asTreeViewAlpha", { enumerable: true, get: function () { return tree_js_1.asTreeViewAlpha; } });
var schemaFactory_js_1 = require("./schemaFactory.js");
Object.defineProperty(exports, "SchemaFactory", { enumerable: true, get: function () { return schemaFactory_js_1.SchemaFactory; } });
var schemaFactoryAlpha_js_1 = require("./schemaFactoryAlpha.js");
Object.defineProperty(exports, "SchemaFactoryAlpha", { enumerable: true, get: function () { return schemaFactoryAlpha_js_1.SchemaFactoryAlpha; } });
var schemaCreationUtilities_js_1 = require("./schemaCreationUtilities.js");
Object.defineProperty(exports, "adaptEnum", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.adaptEnum; } });
Object.defineProperty(exports, "enumFromStrings", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.enumFromStrings; } });
Object.defineProperty(exports, "singletonSchema", { enumerable: true, get: function () { return schemaCreationUtilities_js_1.singletonSchema; } });
var treeNodeApi_js_1 = require("./treeNodeApi.js");
Object.defineProperty(exports, "treeNodeApi", { enumerable: true, get: function () { return treeNodeApi_js_1.treeNodeApi; } });
Object.defineProperty(exports, "tryGetSchema", { enumerable: true, get: function () { return treeNodeApi_js_1.tryGetSchema; } });
var create_js_1 = require("./create.js");
Object.defineProperty(exports, "createFromInsertable", { enumerable: true, get: function () { return create_js_1.createFromInsertable; } });
Object.defineProperty(exports, "cursorFromInsertable", { enumerable: true, get: function () { return create_js_1.cursorFromInsertable; } });
Object.defineProperty(exports, "createFromCursor", { enumerable: true, get: function () { return create_js_1.createFromCursor; } });
var getJsonSchema_js_1 = require("./getJsonSchema.js");
Object.defineProperty(exports, "getJsonSchema", { enumerable: true, get: function () { return getJsonSchema_js_1.getJsonSchema; } });
var getSimpleSchema_js_1 = require("./getSimpleSchema.js");
Object.defineProperty(exports, "getSimpleSchema", { enumerable: true, get: function () { return getSimpleSchema_js_1.getSimpleSchema; } });
var view_js_1 = require("./view.js");
Object.defineProperty(exports, "ViewSchema", { enumerable: true, get: function () { return view_js_1.ViewSchema; } });
var verboseTree_js_1 = require("./verboseTree.js");
Object.defineProperty(exports, "applySchemaToParserOptions", { enumerable: true, get: function () { return verboseTree_js_1.applySchemaToParserOptions; } });
Object.defineProperty(exports, "cursorFromVerbose", { enumerable: true, get: function () { return verboseTree_js_1.cursorFromVerbose; } });
Object.defineProperty(exports, "verboseFromCursor", { enumerable: true, get: function () { return verboseTree_js_1.verboseFromCursor; } });
var customTree_js_1 = require("./customTree.js");
Object.defineProperty(exports, "customFromCursorStored", { enumerable: true, get: function () { return customTree_js_1.customFromCursorStored; } });
Object.defineProperty(exports, "tryStoredSchemaAsArray", { enumerable: true, get: function () { return customTree_js_1.tryStoredSchemaAsArray; } });
var conciseTree_js_1 = require("./conciseTree.js");
Object.defineProperty(exports, "conciseFromCursor", { enumerable: true, get: function () { return conciseTree_js_1.conciseFromCursor; } });
var treeApiBeta_js_1 = require("./treeApiBeta.js");
Object.defineProperty(exports, "TreeBeta", { enumerable: true, get: function () { return treeApiBeta_js_1.TreeBeta; } });
var simpleTreeIndex_js_1 = require("./simpleTreeIndex.js");
Object.defineProperty(exports, "createSimpleTreeIndex", { enumerable: true, get: function () { return simpleTreeIndex_js_1.createSimpleTreeIndex; } });
var identifierIndex_js_1 = require("./identifierIndex.js");
Object.defineProperty(exports, "createIdentifierIndex", { enumerable: true, get: function () { return identifierIndex_js_1.createIdentifierIndex; } });
var storedSchema_js_1 = require("./storedSchema.js");
Object.defineProperty(exports, "extractPersistedSchema", { enumerable: true, get: function () { return storedSchema_js_1.extractPersistedSchema; } });
Object.defineProperty(exports, "comparePersistedSchemaInternal", { enumerable: true, get: function () { return storedSchema_js_1.comparePersistedSchemaInternal; } });
Object.defineProperty(exports, "comparePersistedSchema", { enumerable: true, get: function () { return storedSchema_js_1.comparePersistedSchema; } });
// Exporting the schema (RecursiveObject) to test that recursive types are working correctly.
// These are `@internal` so they can't be included in the `InternalClassTreeTypes` due to https://github.com/microsoft/rushstack/issues/3639
var testRecursiveDomain_js_1 = require("./testRecursiveDomain.js");
Object.defineProperty(exports, "test_RecursiveObject", { enumerable: true, get: function () { return testRecursiveDomain_js_1.RecursiveObject; } });
Object.defineProperty(exports, "test_RecursiveObject_base", { enumerable: true, get: function () { return testRecursiveDomain_js_1.base; } });
Object.defineProperty(exports, "test_RecursiveObjectPojoMode", { enumerable: true, get: function () { return testRecursiveDomain_js_1.RecursiveObjectPojoMode; } });
//# sourceMappingURL=index.js.map