"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.IterableTreeArrayContent = exports.TreeArrayNode = exports.prepareContentForHydration = exports.getTreeNodeForField = exports.normalizeAllowedTypes = exports.areImplicitFieldSchemaEqual = exports.areFieldSchemaEqual = exports.normalizeFieldSchema = exports.FieldSchema = exports.FieldKind = exports.isTreeNodeSchemaClass = exports.tryStoredSchemaAsArray = exports.customFromCursorStored = exports.asTreeViewAlpha = exports.createFromCursor = exports.conciseFromCursor = exports.verboseFromCursor = exports.cursorFromVerbose = exports.applySchemaToParserOptions = exports.tryGetSchema = exports.ViewSchema = exports.comparePersistedSchemaInternal = exports.comparePersistedSchema = exports.extractPersistedSchema = exports.getSimpleSchema = exports.getJsonSchema = exports.createIdentifierIndex = exports.createSimpleTreeIndex = exports.TreeBeta = exports.createFromInsertable = exports.cursorFromInsertable = exports.treeNodeApi = exports.test_RecursiveObjectPojoMode = exports.test_RecursiveObject_base = exports.test_RecursiveObject = exports.singletonSchema = exports.enumFromStrings = exports.adaptEnum = exports.SchemaFactoryAlpha = exports.SchemaFactory = exports.TreeViewConfiguration = exports.getKernel = exports.getOrCreateInnerNode = exports.SimpleContextSlot = exports.HydratedContext = exports.tryDisposeTreeNode = exports.isTreeNode = exports.NodeKind = exports.typeSchemaSymbol = exports.typeNameSymbol = void 0;
exports.nullSchema = exports.handleSchema = exports.booleanSchema = exports.stringSchema = exports.numberSchema = exports.getStoredSchema = exports.toStoredSchema = exports.mapTreeFromNodeData = exports.createUnknownOptionalFieldPolicy = exports.setField = void 0;
var index_js_1 = require("./core/index.js");
Object.defineProperty(exports, "typeNameSymbol", { enumerable: true, get: function () { return index_js_1.typeNameSymbol; } });
Object.defineProperty(exports, "typeSchemaSymbol", { enumerable: true, get: function () { return index_js_1.typeSchemaSymbol; } });
Object.defineProperty(exports, "NodeKind", { enumerable: true, get: function () { return index_js_1.NodeKind; } });
Object.defineProperty(exports, "isTreeNode", { enumerable: true, get: function () { return index_js_1.isTreeNode; } });
Object.defineProperty(exports, "tryDisposeTreeNode", { enumerable: true, get: function () { return index_js_1.tryDisposeTreeNode; } });
Object.defineProperty(exports, "HydratedContext", { enumerable: true, get: function () { return index_js_1.HydratedContext; } });
Object.defineProperty(exports, "SimpleContextSlot", { enumerable: true, get: function () { return index_js_1.SimpleContextSlot; } });
Object.defineProperty(exports, "getOrCreateInnerNode", { enumerable: true, get: function () { return index_js_1.getOrCreateInnerNode; } });
Object.defineProperty(exports, "getKernel", { enumerable: true, get: function () { return index_js_1.getKernel; } });
var index_js_2 = require("./api/index.js");
Object.defineProperty(exports, "TreeViewConfiguration", { enumerable: true, get: function () { return index_js_2.TreeViewConfiguration; } });
Object.defineProperty(exports, "SchemaFactory", { enumerable: true, get: function () { return index_js_2.SchemaFactory; } });
Object.defineProperty(exports, "SchemaFactoryAlpha", { enumerable: true, get: function () { return index_js_2.SchemaFactoryAlpha; } });
Object.defineProperty(exports, "adaptEnum", { enumerable: true, get: function () { return index_js_2.adaptEnum; } });
Object.defineProperty(exports, "enumFromStrings", { enumerable: true, get: function () { return index_js_2.enumFromStrings; } });
Object.defineProperty(exports, "singletonSchema", { enumerable: true, get: function () { return index_js_2.singletonSchema; } });
Object.defineProperty(exports, "test_RecursiveObject", { enumerable: true, get: function () { return index_js_2.test_RecursiveObject; } });
Object.defineProperty(exports, "test_RecursiveObject_base", { enumerable: true, get: function () { return index_js_2.test_RecursiveObject_base; } });
Object.defineProperty(exports, "test_RecursiveObjectPojoMode", { enumerable: true, get: function () { return index_js_2.test_RecursiveObjectPojoMode; } });
Object.defineProperty(exports, "treeNodeApi", { enumerable: true, get: function () { return index_js_2.treeNodeApi; } });
Object.defineProperty(exports, "cursorFromInsertable", { enumerable: true, get: function () { return index_js_2.cursorFromInsertable; } });
Object.defineProperty(exports, "createFromInsertable", { enumerable: true, get: function () { return index_js_2.createFromInsertable; } });
Object.defineProperty(exports, "TreeBeta", { enumerable: true, get: function () { return index_js_2.TreeBeta; } });
Object.defineProperty(exports, "createSimpleTreeIndex", { enumerable: true, get: function () { return index_js_2.createSimpleTreeIndex; } });
Object.defineProperty(exports, "createIdentifierIndex", { enumerable: true, get: function () { return index_js_2.createIdentifierIndex; } });
Object.defineProperty(exports, "getJsonSchema", { enumerable: true, get: function () { return index_js_2.getJsonSchema; } });
Object.defineProperty(exports, "getSimpleSchema", { enumerable: true, get: function () { return index_js_2.getSimpleSchema; } });
Object.defineProperty(exports, "extractPersistedSchema", { enumerable: true, get: function () { return index_js_2.extractPersistedSchema; } });
Object.defineProperty(exports, "comparePersistedSchema", { enumerable: true, get: function () { return index_js_2.comparePersistedSchema; } });
Object.defineProperty(exports, "comparePersistedSchemaInternal", { enumerable: true, get: function () { return index_js_2.comparePersistedSchemaInternal; } });
Object.defineProperty(exports, "ViewSchema", { enumerable: true, get: function () { return index_js_2.ViewSchema; } });
Object.defineProperty(exports, "tryGetSchema", { enumerable: true, get: function () { return index_js_2.tryGetSchema; } });
Object.defineProperty(exports, "applySchemaToParserOptions", { enumerable: true, get: function () { return index_js_2.applySchemaToParserOptions; } });
Object.defineProperty(exports, "cursorFromVerbose", { enumerable: true, get: function () { return index_js_2.cursorFromVerbose; } });
Object.defineProperty(exports, "verboseFromCursor", { enumerable: true, get: function () { return index_js_2.verboseFromCursor; } });
Object.defineProperty(exports, "conciseFromCursor", { enumerable: true, get: function () { return index_js_2.conciseFromCursor; } });
Object.defineProperty(exports, "createFromCursor", { enumerable: true, get: function () { return index_js_2.createFromCursor; } });
Object.defineProperty(exports, "asTreeViewAlpha", { enumerable: true, get: function () { return index_js_2.asTreeViewAlpha; } });
Object.defineProperty(exports, "customFromCursorStored", { enumerable: true, get: function () { return index_js_2.customFromCursorStored; } });
Object.defineProperty(exports, "tryStoredSchemaAsArray", { enumerable: true, get: function () { return index_js_2.tryStoredSchemaAsArray; } });
var schemaTypes_js_1 = require("./schemaTypes.js");
Object.defineProperty(exports, "isTreeNodeSchemaClass", { enumerable: true, get: function () { return schemaTypes_js_1.isTreeNodeSchemaClass; } });
Object.defineProperty(exports, "FieldKind", { enumerable: true, get: function () { return schemaTypes_js_1.FieldKind; } });
Object.defineProperty(exports, "FieldSchema", { enumerable: true, get: function () { return schemaTypes_js_1.FieldSchema; } });
Object.defineProperty(exports, "normalizeFieldSchema", { enumerable: true, get: function () { return schemaTypes_js_1.normalizeFieldSchema; } });
Object.defineProperty(exports, "areFieldSchemaEqual", { enumerable: true, get: function () { return schemaTypes_js_1.areFieldSchemaEqual; } });
Object.defineProperty(exports, "areImplicitFieldSchemaEqual", { enumerable: true, get: function () { return schemaTypes_js_1.areImplicitFieldSchemaEqual; } });
Object.defineProperty(exports, "normalizeAllowedTypes", { enumerable: true, get: function () { return schemaTypes_js_1.normalizeAllowedTypes; } });
var proxies_js_1 = require("./proxies.js");
Object.defineProperty(exports, "getTreeNodeForField", { enumerable: true, get: function () { return proxies_js_1.getTreeNodeForField; } });
Object.defineProperty(exports, "prepareContentForHydration", { enumerable: true, get: function () { return proxies_js_1.prepareContentForHydration; } });
var arrayNode_js_1 = require("./arrayNode.js");
Object.defineProperty(exports, "TreeArrayNode", { enumerable: true, get: function () { return arrayNode_js_1.TreeArrayNode; } });
Object.defineProperty(exports, "IterableTreeArrayContent", { enumerable: true, get: function () { return arrayNode_js_1.IterableTreeArrayContent; } });
var objectNode_js_1 = require("./objectNode.js");
Object.defineProperty(exports, "setField", { enumerable: true, get: function () { return objectNode_js_1.setField; } });
Object.defineProperty(exports, "createUnknownOptionalFieldPolicy", { enumerable: true, get: function () { return objectNode_js_1.createUnknownOptionalFieldPolicy; } });
var toMapTree_js_1 = require("./toMapTree.js");
Object.defineProperty(exports, "mapTreeFromNodeData", { enumerable: true, get: function () { return toMapTree_js_1.mapTreeFromNodeData; } });
var toStoredSchema_js_1 = require("./toStoredSchema.js");
Object.defineProperty(exports, "toStoredSchema", { enumerable: true, get: function () { return toStoredSchema_js_1.toStoredSchema; } });
Object.defineProperty(exports, "getStoredSchema", { enumerable: true, get: function () { return toStoredSchema_js_1.getStoredSchema; } });
var leafNodeSchema_js_1 = require("./leafNodeSchema.js");
Object.defineProperty(exports, "numberSchema", { enumerable: true, get: function () { return leafNodeSchema_js_1.numberSchema; } });
Object.defineProperty(exports, "stringSchema", { enumerable: true, get: function () { return leafNodeSchema_js_1.stringSchema; } });
Object.defineProperty(exports, "booleanSchema", { enumerable: true, get: function () { return leafNodeSchema_js_1.booleanSchema; } });
Object.defineProperty(exports, "handleSchema", { enumerable: true, get: function () { return leafNodeSchema_js_1.handleSchema; } });
Object.defineProperty(exports, "nullSchema", { enumerable: true, get: function () { return leafNodeSchema_js_1.nullSchema; } });
//# sourceMappingURL=index.js.map