"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isObjectNodeSchema = exports.ObjectNodeSchema = void 0;
const index_js_1 = require("./core/index.js");
exports.ObjectNodeSchema = {
    /**
     * instanceof-based narrowing support for ObjectNodeSchema in Javascript and TypeScript 5.3 or newer.
     */
    [Symbol.hasInstance](value) {
        return isObjectNodeSchema(value);
    },
};
function isObjectNodeSchema(schema) {
    return schema.kind === index_js_1.NodeKind.Object;
}
exports.isObjectNodeSchema = isObjectNodeSchema;
//# sourceMappingURL=objectNodeTypes.js.map