"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.count = exports.find = exports.compareStrings = exports.transformObjectMap = exports.assertValidRangeIndices = exports.capitalize = exports.disposeSymbol = exports.compareNamed = exports.oneFromSet = exports.invertMap = exports.objectToMap = exports.assertNonNegativeSafeInteger = exports.assertValidRange = exports.assertValidIndex = exports.filterIterable = exports.mapIterable = exports.makeArray = exports.JsonCompatibleReadOnlySchema = exports.isReadonlyArray = exports.isJsonObject = exports.getOrCreate = exports.getOrAddEmptyToMap = exports.fail = exports.compareSets = exports.clone = exports.asMutable = exports.StackyIterator = exports.OffsetListFactory = exports.nestedSetContains = exports.addToNestedSet = exports.nestedMapFromFlatList = exports.nestedMapToFlatList = exports.mapNestedMap = exports.tryGetFromNestedMap = exports.tryAddToNestedMap = exports.setInNestedMap = exports.populateNestedMap = exports.SizedNestedMap = exports.forEachInNestedMap = exports.getOrDefaultInNestedMap = exports.getOrAddInNestedMap = exports.getOrAddInMapLazy = exports.getOrAddInMap = exports.deleteFromNestedMap = exports.extractFromOpaque = exports.brandOpaque = exports.brandedStringType = exports.brandedNumberType = exports.BrandedType = exports.brand = void 0;
exports.breakingClass = exports.throwIfBroken = exports.breakingMethod = exports.Breakable = exports.fakeIdAllocator = exports.idAllocatorFromState = exports.idAllocatorFromMaxId = exports.RangeMap = exports.brandedSlot = exports.getOrCreateSlotContent = exports.unsafeArrayToTuple = exports.ReferenceCountedBase = exports.copyProperty = exports.defineLazyCachedProperty = exports.hasSingle = exports.hasSome = exports.getLast = void 0;
var brand_js_1 = require("./brand.js");
Object.defineProperty(exports, "brand", { enumerable: true, get: function () { return brand_js_1.brand; } });
Object.defineProperty(exports, "BrandedType", { enumerable: true, get: function () { return brand_js_1.BrandedType; } });
var typeboxBrand_js_1 = require("./typeboxBrand.js");
Object.defineProperty(exports, "brandedNumberType", { enumerable: true, get: function () { return typeboxBrand_js_1.brandedNumberType; } });
Object.defineProperty(exports, "brandedStringType", { enumerable: true, get: function () { return typeboxBrand_js_1.brandedStringType; } });
var opaque_js_1 = require("./opaque.js");
Object.defineProperty(exports, "brandOpaque", { enumerable: true, get: function () { return opaque_js_1.brandOpaque; } });
Object.defineProperty(exports, "extractFromOpaque", { enumerable: true, get: function () { return opaque_js_1.extractFromOpaque; } });
var nestedMap_js_1 = require("./nestedMap.js");
Object.defineProperty(exports, "deleteFromNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.deleteFromNestedMap; } });
Object.defineProperty(exports, "getOrAddInMap", { enumerable: true, get: function () { return nestedMap_js_1.getOrAddInMap; } });
Object.defineProperty(exports, "getOrAddInMapLazy", { enumerable: true, get: function () { return nestedMap_js_1.getOrAddInMapLazy; } });
Object.defineProperty(exports, "getOrAddInNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.getOrAddInNestedMap; } });
Object.defineProperty(exports, "getOrDefaultInNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.getOrDefaultInNestedMap; } });
Object.defineProperty(exports, "forEachInNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.forEachInNestedMap; } });
Object.defineProperty(exports, "SizedNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.SizedNestedMap; } });
Object.defineProperty(exports, "populateNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.populateNestedMap; } });
Object.defineProperty(exports, "setInNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.setInNestedMap; } });
Object.defineProperty(exports, "tryAddToNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.tryAddToNestedMap; } });
Object.defineProperty(exports, "tryGetFromNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.tryGetFromNestedMap; } });
Object.defineProperty(exports, "mapNestedMap", { enumerable: true, get: function () { return nestedMap_js_1.mapNestedMap; } });
Object.defineProperty(exports, "nestedMapToFlatList", { enumerable: true, get: function () { return nestedMap_js_1.nestedMapToFlatList; } });
Object.defineProperty(exports, "nestedMapFromFlatList", { enumerable: true, get: function () { return nestedMap_js_1.nestedMapFromFlatList; } });
var nestedSet_js_1 = require("./nestedSet.js");
Object.defineProperty(exports, "addToNestedSet", { enumerable: true, get: function () { return nestedSet_js_1.addToNestedSet; } });
Object.defineProperty(exports, "nestedSetContains", { enumerable: true, get: function () { return nestedSet_js_1.nestedSetContains; } });
var offsetList_js_1 = require("./offsetList.js");
Object.defineProperty(exports, "OffsetListFactory", { enumerable: true, get: function () { return offsetList_js_1.OffsetListFactory; } });
var stackyIterator_js_1 = require("./stackyIterator.js");
Object.defineProperty(exports, "StackyIterator", { enumerable: true, get: function () { return stackyIterator_js_1.StackyIterator; } });
var utils_js_1 = require("./utils.js");
Object.defineProperty(exports, "asMutable", { enumerable: true, get: function () { return utils_js_1.asMutable; } });
Object.defineProperty(exports, "clone", { enumerable: true, get: function () { return utils_js_1.clone; } });
Object.defineProperty(exports, "compareSets", { enumerable: true, get: function () { return utils_js_1.compareSets; } });
Object.defineProperty(exports, "fail", { enumerable: true, get: function () { return utils_js_1.fail; } });
Object.defineProperty(exports, "getOrAddEmptyToMap", { enumerable: true, get: function () { return utils_js_1.getOrAddEmptyToMap; } });
Object.defineProperty(exports, "getOrCreate", { enumerable: true, get: function () { return utils_js_1.getOrCreate; } });
Object.defineProperty(exports, "isJsonObject", { enumerable: true, get: function () { return utils_js_1.isJsonObject; } });
Object.defineProperty(exports, "isReadonlyArray", { enumerable: true, get: function () { return utils_js_1.isReadonlyArray; } });
Object.defineProperty(exports, "JsonCompatibleReadOnlySchema", { enumerable: true, get: function () { return utils_js_1.JsonCompatibleReadOnlySchema; } });
Object.defineProperty(exports, "makeArray", { enumerable: true, get: function () { return utils_js_1.makeArray; } });
Object.defineProperty(exports, "mapIterable", { enumerable: true, get: function () { return utils_js_1.mapIterable; } });
Object.defineProperty(exports, "filterIterable", { enumerable: true, get: function () { return utils_js_1.filterIterable; } });
Object.defineProperty(exports, "assertValidIndex", { enumerable: true, get: function () { return utils_js_1.assertValidIndex; } });
Object.defineProperty(exports, "assertValidRange", { enumerable: true, get: function () { return utils_js_1.assertValidRange; } });
Object.defineProperty(exports, "assertNonNegativeSafeInteger", { enumerable: true, get: function () { return utils_js_1.assertNonNegativeSafeInteger; } });
Object.defineProperty(exports, "objectToMap", { enumerable: true, get: function () { return utils_js_1.objectToMap; } });
Object.defineProperty(exports, "invertMap", { enumerable: true, get: function () { return utils_js_1.invertMap; } });
Object.defineProperty(exports, "oneFromSet", { enumerable: true, get: function () { return utils_js_1.oneFromSet; } });
Object.defineProperty(exports, "compareNamed", { enumerable: true, get: function () { return utils_js_1.compareNamed; } });
Object.defineProperty(exports, "disposeSymbol", { enumerable: true, get: function () { return utils_js_1.disposeSymbol; } });
Object.defineProperty(exports, "capitalize", { enumerable: true, get: function () { return utils_js_1.capitalize; } });
Object.defineProperty(exports, "assertValidRangeIndices", { enumerable: true, get: function () { return utils_js_1.assertValidRangeIndices; } });
Object.defineProperty(exports, "transformObjectMap", { enumerable: true, get: function () { return utils_js_1.transformObjectMap; } });
Object.defineProperty(exports, "compareStrings", { enumerable: true, get: function () { return utils_js_1.compareStrings; } });
Object.defineProperty(exports, "find", { enumerable: true, get: function () { return utils_js_1.find; } });
Object.defineProperty(exports, "count", { enumerable: true, get: function () { return utils_js_1.count; } });
Object.defineProperty(exports, "getLast", { enumerable: true, get: function () { return utils_js_1.getLast; } });
Object.defineProperty(exports, "hasSome", { enumerable: true, get: function () { return utils_js_1.hasSome; } });
Object.defineProperty(exports, "hasSingle", { enumerable: true, get: function () { return utils_js_1.hasSingle; } });
Object.defineProperty(exports, "defineLazyCachedProperty", { enumerable: true, get: function () { return utils_js_1.defineLazyCachedProperty; } });
Object.defineProperty(exports, "copyProperty", { enumerable: true, get: function () { return utils_js_1.copyPropertyIfDefined; } });
var referenceCounting_js_1 = require("./referenceCounting.js");
Object.defineProperty(exports, "ReferenceCountedBase", { enumerable: true, get: function () { return referenceCounting_js_1.ReferenceCountedBase; } });
var typeUtils_js_1 = require("./typeUtils.js");
Object.defineProperty(exports, "unsafeArrayToTuple", { enumerable: true, get: function () { return typeUtils_js_1.unsafeArrayToTuple; } });
var brandedMap_js_1 = require("./brandedMap.js");
Object.defineProperty(exports, "getOrCreateSlotContent", { enumerable: true, get: function () { return brandedMap_js_1.getOrCreateSlotContent; } });
Object.defineProperty(exports, "brandedSlot", { enumerable: true, get: function () { return brandedMap_js_1.brandedSlot; } });
var rangeMap_js_1 = require("./rangeMap.js");
Object.defineProperty(exports, "RangeMap", { enumerable: true, get: function () { return rangeMap_js_1.RangeMap; } });
var idAllocator_js_1 = require("./idAllocator.js");
Object.defineProperty(exports, "idAllocatorFromMaxId", { enumerable: true, get: function () { return idAllocator_js_1.idAllocatorFromMaxId; } });
Object.defineProperty(exports, "idAllocatorFromState", { enumerable: true, get: function () { return idAllocator_js_1.idAllocatorFromState; } });
Object.defineProperty(exports, "fakeIdAllocator", { enumerable: true, get: function () { return idAllocator_js_1.fakeIdAllocator; } });
var breakable_js_1 = require("./breakable.js");
Object.defineProperty(exports, "Breakable", { enumerable: true, get: function () { return breakable_js_1.Breakable; } });
Object.defineProperty(exports, "breakingMethod", { enumerable: true, get: function () { return breakable_js_1.breakingMethod; } });
Object.defineProperty(exports, "throwIfBroken", { enumerable: true, get: function () { return breakable_js_1.throwIfBroken; } });
Object.defineProperty(exports, "breakingClass", { enumerable: true, get: function () { return breakable_js_1.breakingClass; } });
//# sourceMappingURL=index.js.map