/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { type NumberOptions, type TUnsafe } from "@sinclair/typebox";
/**
 * Create a TypeBox string schema for a branded string type.
 * This only validates that the value is a string,
 * and not that it came from the correct branded type (that information is lost when serialized).
 */
export declare function brandedStringType<T extends string>(): TUnsafe<T>;
/**
 * Create a TypeBox number schema for a branded number type.
 * {@link brandedStringType} but for numbers.
 */
export declare function brandedNumberType<T extends number>(options?: NumberOptions | undefined): TUnsafe<T>;
//# sourceMappingURL=typeboxBrand.d.ts.map