/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { RangeMap } from "../../util/index.js";
export function addCrossFieldQuery(set, revision, id, count) {
    setInCrossFieldMap(set, revision, id, count, true);
}
export function setInCrossFieldMap(map, revision, id, count, value) {
    let rangeMap = map.get(revision);
    if (rangeMap === undefined) {
        rangeMap = new RangeMap();
        map.set(revision, rangeMap);
    }
    rangeMap.set(id, count, value);
}
export function getFirstFromCrossFieldMap(map, revision, id, count) {
    const rangeMap = map.has(revision) ? map.get(revision) : new RangeMap();
    return rangeMap.get(id, count);
}
/**
 */
export var CrossFieldTarget;
(function (CrossFieldTarget) {
    CrossFieldTarget[CrossFieldTarget["Source"] = 0] = "Source";
    CrossFieldTarget[CrossFieldTarget["Destination"] = 1] = "Destination";
})(CrossFieldTarget || (CrossFieldTarget = {}));
//# sourceMappingURL=crossFieldQueries.js.map