/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { type IJsonCodec } from "../../codec/index.js";
import type { ChangeEncodingContext, EncodedRevisionTag, RevisionTag } from "../../core/index.js";
import { type JsonCompatibleReadOnly } from "../../util/index.js";
import { type Encoded } from "./formatV2.js";
import { type Changeset, type MarkEffect } from "./types.js";
import type { FieldChangeEncodingContext } from "../index.js";
import type { SequenceCodecHelpers } from "./helperTypes.js";
export declare function makeV2CodecHelpers(revisionTagCodec: IJsonCodec<RevisionTag, EncodedRevisionTag, EncodedRevisionTag, ChangeEncodingContext>): SequenceCodecHelpers<MarkEffect, Encoded.MarkEffect>;
export declare function makeV2Codec(revisionTagCodec: IJsonCodec<RevisionTag, EncodedRevisionTag, EncodedRevisionTag, ChangeEncodingContext>): IJsonCodec<Changeset, JsonCompatibleReadOnly, JsonCompatibleReadOnly, FieldChangeEncodingContext>;
//# sourceMappingURL=sequenceFieldCodecV2.d.ts.map