/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { makeCodecFamily } from "../../codec/index.js";
import { makeV1Codec } from "./sequenceFieldCodecV1.js";
import { makeV2Codec } from "./sequenceFieldCodecV2.js";
import { makeV3Codec } from "./sequenceFieldCodecV3.js";
export const sequenceFieldChangeCodecFactory = (revisionTagCodec) => makeCodecFamily([
    [1, makeV1Codec(revisionTagCodec)],
    [2, makeV2Codec(revisionTagCodec)],
    [3, makeV3Codec(revisionTagCodec)],
]);
//# sourceMappingURL=sequenceFieldCodecs.js.map