/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { customFromCursor } from "./customTree.js";
import { getUnhydratedContext } from "../createContext.js";
/**
 * Used to read a node cursor as a ConciseTree.
 */
export function conciseFromCursor(reader, rootSchema, options) {
    const config = {
        useStoredKeys: false,
        ...options,
    };
    const schemaMap = getUnhydratedContext(rootSchema).schema;
    return conciseFromCursorInner(reader, config, schemaMap);
}
function conciseFromCursorInner(reader, options, schema) {
    return customFromCursor(reader, options, schema, conciseFromCursorInner);
}
//# sourceMappingURL=conciseTree.js.map