/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { type ImplicitFieldSchema } from "../schemaTypes.js";
import type { TreeNode } from "../core/index.js";
import type { TreeView } from "./tree.js";
import { type SimpleTreeIndex } from "./simpleTreeIndex.js";
/**
 * An index that returns tree nodes given their associated identifiers.
 *
 * @alpha
 */
export type IdentifierIndex = SimpleTreeIndex<string, TreeNode>;
/**
 * Creates an {@link IdentifierIndex} for a given {@link TreeView}.
 *
 * @alpha
 */
export declare function createIdentifierIndex<TSchema extends ImplicitFieldSchema>(view: TreeView<TSchema>): IdentifierIndex;
//# sourceMappingURL=identifierIndex.d.ts.map