/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
export { TreeViewConfiguration, asTreeViewAlpha, } from "./tree.js";
export { SchemaFactory, } from "./schemaFactory.js";
export { SchemaFactoryAlpha } from "./schemaFactoryAlpha.js";
export { adaptEnum, enumFromStrings, singletonSchema, } from "./schemaCreationUtilities.js";
export { treeNodeApi, tryGetSchema } from "./treeNodeApi.js";
export { createFromInsertable, cursorFromInsertable, createFromCursor } from "./create.js";
export { getJsonSchema } from "./getJsonSchema.js";
export { getSimpleSchema } from "./getSimpleSchema.js";
export { ViewSchema } from "./view.js";
export { applySchemaToParserOptions, cursorFromVerbose, verboseFromCursor, } from "./verboseTree.js";
export { customFromCursorStored, tryStoredSchemaAsArray, } from "./customTree.js";
export { conciseFromCursor } from "./conciseTree.js";
export { TreeBeta } from "./treeApiBeta.js";
export { createSimpleTreeIndex } from "./simpleTreeIndex.js";
export { createIdentifierIndex, } from "./identifierIndex.js";
export { extractPersistedSchema, comparePersistedSchemaInternal, comparePersistedSchema, } from "./storedSchema.js";
// Exporting the schema (RecursiveObject) to test that recursive types are working correctly.
// These are `@internal` so they can't be included in the `InternalClassTreeTypes` due to https://github.com/microsoft/rushstack/issues/3639
export { RecursiveObject as test_RecursiveObject, base as test_RecursiveObject_base, RecursiveObjectPojoMode as test_RecursiveObjectPojoMode, } from "./testRecursiveDomain.js";
//# sourceMappingURL=index.js.map