/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { type TreeFieldStoredSchema, type TreeNodeStoredSchema, type TreeStoredSchema, type TreeTypeSet } from "../core/index.js";
import { type TreeNodeSchema } from "./core/index.js";
import { type ImplicitAllowedTypes, type ImplicitFieldSchema } from "./schemaTypes.js";
/**
 * Converts a {@link ImplicitFieldSchema} into a {@link TreeStoredSchema}.
 */
export declare function toStoredSchema(root: ImplicitFieldSchema): TreeStoredSchema;
/**
 * Normalizes an {@link ImplicitFieldSchema} into a {@link TreeFieldSchema}.
 */
export declare function convertField(schema: ImplicitFieldSchema): TreeFieldStoredSchema;
/**
 * Normalizes an {@link ImplicitAllowedTypes} into an {@link TreeTypeSet}.
 */
export declare function convertAllowedTypes(schema: ImplicitAllowedTypes): TreeTypeSet;
/**
 * Converts a {@link TreeNodeSchema} into a {@link TreeNodeStoredSchema}.
 */
export declare function getStoredSchema(schema: TreeNodeSchema): TreeNodeStoredSchema;
//# sourceMappingURL=toStoredSchema.d.ts.map