/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { walkAllowedTypes } from "./core/index.js";
import { normalizeFieldSchema } from "./schemaTypes.js";
/**
 * Traverses all {@link TreeNodeSchema} schema reachable from `schema`, applying the visitor pattern.
 */
export function walkFieldSchema(schema, visitor, visitedSet = new Set()) {
    walkAllowedTypes(normalizeFieldSchema(schema).allowedTypeSet, visitor, visitedSet);
}
//# sourceMappingURL=walkFieldSchema.js.map